-- Trivia Ex SERVER V 003 by chill  LUA 5
-- Serialisation by RabidWombat, modded to exclude functions, also the Ranking from RabidWombat (Great Idea to reference the tables !!)
-- Thx to the Help of Queeny and UvW, all the testing and improving and Ideas, I wouldn't have done it without

-- This script is opensource, that means that anybody may edit/copy this code
-- and I will not come and cry for money, if you take bits to make a even more useless script
-- then leave a note over it with my name, would be cool :).

--------
-- DC Funcs
--------

dcpp:setListener( "timer","TriviaEx",
	function()
		if (TrivEx._Config.trivrun == 1) then
			TrivEx:OnTimer()
		end
	end
)

dcpp:setListener( "chat","TriviaEx",
	function(hub, user, data)
		local snick = user:getNick()
		TrivEx:ParseData("main", hub, snick, data)
	end
)

dcpp:setListener( "pm","TriviaEx",
	function(hub, user, data)
		local snick = user:getNick()
		TrivEx:ParseData("pm", hub, snick, data)
	end
)	

---------------------------------------------------------------------------------------

---------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------

--				GLOBALS						     --

---------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------

---------------------------------------------------------------------------------------

-- Main Table

TrivEx = TrivEx or {}

-- Settings

TrivEx._Sets = {}

TrivEx._Sets.Version = 	"003"					-- Script Version
TrivEx._Sets.Author = 	"Chill"					-- Script Author

-- Profiles

TrivEx._Profiles = {}

-- Load Settings

dofile("scripts/ChillGameServer/TriviaEx.Server/TriviaEx.Server.cfg")

--------------------------------------------------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------------------------------------------------
--//			MAIN SCRIPT

--------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------

---------------------------------------------------------------------------------------

--	NO EDITING PAST THIS POINT UNLESS YOU KNOW WHAT YOU ARE DOING

---------------------------------------------------------------------------------------

---------------------------------------------------------------------------------------
--	Adjust Timers to seconds

---------------------------------------------------------------------------------------
TrivEx._Sets.breaktime = TrivEx._Sets.breaktime * 60
TrivEx._Sets.timebreak = TrivEx._Sets.timebreak * 60


TrivEx._Sets.TrivConfigFile = "TriviaExConfig.txt"

TrivEx._Sets.ScoresFile = "TriviaExScores.txt"

TrivEx._Sets.HallofFamesFile = "TriviaHallofFames.txt"


TrivEx._Questions = {n=0}

---------------------------------------------------------------------------------------

--	TRIVIA EX CONFIG

---------------------------------------------------------------------------------------
TrivEx._Config = {}

------------------------

-- TRIVIA EX PROFILES --

------------------------
TrivEx._Config._Profiles = {}

TrivEx._Config._Profiles.Normal = {
}

TrivEx._Config._Profiles.Config = {
	["$ALL"] = 1
}

TrivEx._Config._Profiles["Config+"] = {
	["$OP"] = 1,
	--["Chill_Inc"] = 1  -- Nicks to be allowed in allhubs here
}

TrivEx._Config._Profiles["Config++"] = {
}

TrivEx._Config.questionfile = "TriviaEx.Questions-1.txt"	-- The name of the Questionfile Questiondefaultformat = category$questions$answer
TrivEx._Config.trivrun =	1				-- 1 = trivia runs, 0 = trivia is stopped
TrivEx._Config.showquesmode = 	1				-- Questions Mode 1 = Random, 2 = Sequential (e.g. 1,2,3)

TrivEx._Config.trivskip = 	0				-- 1 = trivskip enabled, 0 = disabled

TrivEx._Config.trivhint = 	0				-- 1 = trivhint enabled, 0 = disabled
TrivEx._Config.sequentialnum = 	0
local f = loadfile(TrivEx._Sets.folder.."/"..TrivEx._Sets.TrivConfigFile)
if f then
	f()
end

---------------------------------------------------------------------------------------

--	TRIVIA Data

---------------------------------------------------------------------------------------
TrivEx.Data = {}

TrivEx.Data.HelpNormal = "-- Trivia Ex V."..TrivEx._Sets.Version.." by "..TrivEx._Sets.Author.." --\r\n\r\n\tPrefixes: ! + -\r\n\r\n"..
	"\t\t-< NORMAL >-\r\n"..
	"\ttrivhelp   - This Text\r\n"..
	"\t\r\n"..
	"\ttrivscore   - Shows the top "..TrivEx._Sets.displscorers.." scorers\r\n"..
	"\ttrivmyscore   - Shows your score\r\n"..
	"\ttrivstats   - Shows the top "..TrivEx._Sets.displtoptrivs.." player stats\r\n"..
	"\ttrivhf   - Shows the top "..TrivEx._Sets.displtoptrivs.." from the \"Hall of Fame\"\r\n"..
	"\ttrivskip   - Lets you skipp the current question, if enabled\r\n"..
	"\ttrivhint   - Gives you a hint, if enabled\r\n"..
	"\t\r\n"

TrivEx.Data.HelpConfig = TrivEx.Data.HelpNormal..
	"\t\t-< Config >-\r\n"..
	"\ttrivstart  - Start the Trivia\r\n"..
	"\ttrivstop   - Stop the Trivia\r\n"..
	"\ttrivquestion <QuestionNr.>   - Starts with questionNr.\r\n"
	if (TrivEx._Sets.quesmode == 1) then
		TrivEx.Data.HelpConfig = TrivEx.Data.HelpConfig.."\ttrivaddq <Category/Question/Answers>   - Lets you add a question\r\n"
	elseif (TrivEx._Sets.quesmode == 2) then
		TrivEx.Data.HelpConfig = TrivEx.Data.HelpConfig.."\ttrivaddq <Question/Answers>   - Lets you add a question\r\n"
	end
	TrivEx.Data.HelpConfig = TrivEx.Data.HelpConfig.."\t\r\n"

TrivEx.Data["HelpConfig+"] = TrivEx.Data.HelpConfig..
	"\t\t-< Config+ >-\r\n"..
	"\ttriviaskip   - Enables/Disables TriviaSkip\r\n"..
	"\ttriviahint   - Enables/Disables TrivHint\r\n"..
	"\ttriviascorereset   - Lets you reset all scores\r\n"..
	"\ttriviachangemode   - Changes the Questionmode\r\n"..
	"\ttrivialistqfiles   - Lists the questionfiles\r\n"..
	"\ttrivialoadqfile   - Loads a questionfile\r\n"..
	"\t\r\n"

TrivEx.Data["HelpConfig++"] = TrivEx.Data["HelpConfig+"]..
	"\t\t-< Config++ >-\r\n"..
	"\ttriviaprofile <Profile> <Prof/Nick>  - List/Add/Del TriviaProfiles ( \"$ALL\" allows all, \"$OP\" allows al OPs, <nick> allows that nick )\r\n"..
	"\t\r\n"

---------------------------------------------------------------------------------------

--	TRIVIA FUNCTIONS

---------------------------------------------------------------------------------------

function TrivEx:Main()

	-- Scores and Ranking
	if self._Scores then
		self:WriteTable(self._Scores,"TrivEx._Scores",self._Sets.folder.."/"..self._Sets.ScoresFile)
	else
		self._Scores = {}
	end
	local f = loadfile(self._Sets.folder.."/"..self._Sets.ScoresFile)
	if f then
		f()
	end

	-- Hall of Fame
	if self._HallofFames then
		self:WriteTable(self._HallofFames,"TrivEx._HallofFames",self._Sets.folder.."/"..self._Sets.HallofFamesFile)
	else
		self._HallofFames = {}
	end
	local f = loadfile(self._Sets.folder.."/"..self._Sets.HallofFamesFile)
	if f then
		f()
	end


	self:BuildHoFScores()

	curTriv.totalques = self:GetTotalQues()
	self:BuildRankTable()

	GameServer:AddServer( "Trivia" )

end

function TrivEx:BuildHoFScores()
	self._HoFScores = {
		_Score = {},
		_lowScore = 0,
		_Answers = {},
		_lowAnswers = 0,
		_Run = {},
		_lowRun = 0,
	}

	local fames = self._HallofFames
	local hof = self._HoFScores

	table.foreach(fames, function(nick,v)
		table.foreach(v, function(type, val)
			if (type ~= "Nick") then
				table.insert(hof["_"..type], v)
				self:SortHoF(type)
			end
		end)
	end)
end
			

function TrivEx:BuildRankTable()
	self._Ranks = {}
	table.foreach(self._Scores, function(_,v)
		table.insert(self._Ranks,v)
	end)
	self:SetRanks()
end

function TrivEx:SortRankTable(bytype, reverse)
	if reverse then
		table.sort(self._Ranks, function(a,b) return( a[bytype] < b[bytype] ) end)
	else
		table.sort(self._Ranks, function(a,b) return( a[bytype] > b[bytype] ) end)
	end
end

function TrivEx:SetRanks()
	self:SortRankTable("Score")
	table.foreachi(self._Ranks, function(pos,v)
		local snick = v.Nick
		local Ov = snick
		local Und = snick
		if self._Ranks[(pos - 1)] then
			Ov = self._Ranks[(pos - 1)].Nick
		end
		if self._Ranks[(pos + 1)] then
			Und = self._Ranks[(pos + 1)].Nick
		end
		v.Rank.Pos = pos
		v.Rank.Over = Ov
		v.Rank.Under = Und
	end)
end

function TrivEx:UpdHallofFame(snick, points, answers)

	-- Hall Of Fame
	local hof = self._HoFScores
	local fames = self._HallofFames

	local ownscore = self._Scores[snick].Score
	local ownrun = self._Scores[snick].Streak

	local hofToDo = {}
	table.insert(hofToDo, { "Score", ownscore, points })
	table.insert(hofToDo, { "Run", ownrun })

	table.foreachi(hofToDo, function(_,v)

		local stype = v[1]
		local ownval = v[2]
		local curval = v[3]

		--Check if aready in HallOfFames and Update
		if curval and fames[snick] and fames[snick][stype] then
			fames[snick][stype] = fames[snick][stype] + curval
			self:SortHoF(stype)

		-- Check if should be added
		elseif (ownval > hof["_low"..stype]) then

			fames[snick] = fames[snick] or { Nick = snick }
		
			if fames[snick][stype] then
				if (ownval > fames[snick][stype]) then
					fames[snick][stype] = ownval
					self:SortHoF(stype)
				end
			else
				fames[snick][stype] = ownval
				-- add User
				table.insert(hof["_"..stype], fames[snick])
				self:SortHoF(stype)
				self:SendToPlayers("\""..snick.."\" enters the Hall of Fame by "..stype)
			end
		end
	end)
end

function TrivEx:SortHoF(bytype, reverse)

	local thof = self._HoFScores["_"..bytype]

	if reverse then
		table.sort(thof, function(a,b) return( a[bytype] < b[bytype] ) end)
	else
		table.sort(thof, function(a,b) return( a[bytype] > b[bytype] ) end)
	end

	local sentries = table.getn(thof)
	if (sentries > self._Sets.halloffamers) then
		table.remove(thof)
	end

	local sentries = table.getn(thof)
	if (sentries ~= 0) and (sentries ==  self._Sets.halloffamers)then
		self._HoFScores["_low"..bytype] = thof[table.getn(thof)][bytype]
	end

	self:WriteTable(self._HallofFames,"TrivEx._HallofFames",self._Sets.folder.."/"..self._Sets.HallofFamesFile)

end

function TrivEx:GetTotalQues()
	local handle = io.open(self._Sets.quesfolder.."/"..self._Config.questionfile,"r")
	local count = 0
	if handle then
		for line in handle:lines() do
			count = count + 1
		end
		handle:close()
	end
	return(count)
end

function TrivEx:CheckOwnNick(shub, snick)
	if GameServer and GameServer:IsHub(shub, "Trivia") then
		return 1
	end
end


function TrivEx:ParseData(mode, shub, snick, data)

	--Check for Right Nick
	local ret = self:CheckOwnNick(shub, snick)
	if not ret then
		return
	end

	local _,_,cmd = string.find( data, "^["..self._Sets.prefixes.."](%w+)")

	if cmd then
		cmd = string.lower(cmd)

		if self._Cmds[cmd] then
			self._Cmds[cmd](self, shub, snick, data)
			return
		end

	elseif data then

		local corrans = table.foreachi(curTriv.ans, function(_,v)
			if (string.lower(data) == string.lower(v)) then
				return v
			end
		end)

		if corrans and (not curTriv:GetGetQues()) then
			-- SetGetQues
			curTriv:SetGetQues(1)

			local ansTime = string.format("%.2f",(os.clock()-curTriv.start)) -- Get Answering Time in sec.

			if (TrivEx._Sets.showcorrectanswer == 1) then
				-- Show right answer
				self:SendToPlayers("Correct "..snick.." the answer was \""..corrans.."\", You get "..curTriv.points.." Point(s). Answer solved in "..ansTime.." sec.")
			elseif (TrivEx._Sets.showcorrectanswer == 2) then
				-- Show right answer
				self:SendToPlayers("Correct "..snick.." the answer was \""..corrans.."\", You get "..curTriv.points.." Point(s).")
			end

			-- Show other answeres if present
			if curTriv.availans > 1 then
				curTriv:ShowAnswer()
			end

			-- Update Scores
			if self._Scores[snick] then
				self._Scores[snick].Score = self._Scores[snick].Score + curTriv.points
				self._Scores[snick].TotTime = self._Scores[snick].TotTime + ansTime
				self._Scores[snick].AnsQues = self._Scores[snick].AnsQues + 1
				self._Scores[snick].AvTime = tonumber(string.format("%.2f",self._Scores[snick].TotTime/self._Scores[snick].AnsQues))
			else
				self._Scores[snick] = {}
				self._Scores[snick].Nick = snick
				self._Scores[snick].Score = curTriv.points
				self._Scores[snick].Streak = 1
				self._Scores[snick].AnsQues = 1
				self._Scores[snick].TotTime = tonumber(ansTime)
				-- Averagetime + Offset (against one time answeres)
				self._Scores[snick].AvTime = tonumber(ansTime) + 30
				self._Scores[snick].Rank = {
					Pos = 0,
					Over = "",
					Under = "",
				}
				table.insert(self._Ranks, self._Scores[snick])
			end

			-- Update Ranks
			self:SetRanks()

			if (self._Sets.showscore == 1) then

				local difftxt = ""

				if (self._Scores[snick].Rank.Over ~= snick) then
					
					local Over = self._Scores[snick].Rank.Over
					local diff =  self._Scores[Over].Score - self._Scores[snick].Score

					difftxt = diff.." Point(s) behind "..Over

				else
					local Under = self._Scores[snick].Rank.Under
					local diff =  self._Scores[snick].Score - self._Scores[Under].Score

					difftxt = diff.." Point(s) before "..Under
				end
				
				self:SendToPlayers(snick.."'s Stats, Score: "..self._Scores[snick].Score.." Point(s), Longest Run: "..self._Scores[snick].Streak)
				self:SendToPlayers(" - Rank: ( "..self._Scores[snick].Rank.Pos.." / "..table.getn(self._Ranks).." ), "..difftxt)
				self:SendToPlayers(" - Answerd Questions: "..self._Scores[snick].AnsQues..", Average Answering Time: "..self._Scores[snick].AvTime.." sec.")

			elseif (self._Sets.showscore == 2) then

				
				local difftxt = ""

				if (self._Scores[snick].Rank.Over ~= snick) then
					
					local Over = self._Scores[snick].Rank.Over
					local diff =  self._Scores[Over].Score - self._Scores[snick].Score

					difftxt = diff.." Point(s) behind "..Over

				else
					local Under = self._Scores[snick].Rank.Under
					local diff =  self._Scores[snick].Score - self._Scores[Under].Score

					difftxt = diff.." Point(s) before "..Under
				end

				self:SendToPlayers(snick.."'s Stats, Score: "..self._Scores[snick].Score.." Point(s), Rank: ("..self._Scores[snick].Rank.Pos.."/"..table.getn(self._Ranks).."), "..difftxt)

			elseif (self._Sets.showscore == 3) then

				self:SendToPlayers(snick.."'s Stats, Score: "..self._Scores[snick].Score.." Point(s)")

			end

			-- Check for Streak
			curTriv.streak:UpdStreak(snick)

			-- Update Hall of Fame by Points and Answered Questions
			self:UpdHallofFame(snick, curTriv.points, 1)

		end

	end

end

function TrivEx:OnTimer()

	-- Load Questions if needed
	if (table.getn(self._Questions) == 0) then
		self:LoadQuestions()
	end

	-- Check if Trivia should be paused
	if (self._Sets.dobreak == 1) then
		if (not curTriv:Pause()) then
			-- Update TimeBreak
			TrivTimers.timebreak = TrivTimers.timebreak + 1
			if (TrivTimers.timebreak >= self._Sets.timebreak) and curTriv:GetGetQues() then
				curTriv:SetPause(1)
				TrivTimers.timebreak = 0
				TrivTimers.breaktime = 0
				self:SendToPlayers("Short Trivia break for "..(self._Sets.breaktime/60).." min.")
			end
		end
		if curTriv:Pause() then
			-- Update BreakTime
			TrivTimers.breaktime = TrivTimers.breaktime + 1
			if (TrivTimers.breaktime >= self._Sets.breaktime) then
				curTriv:SetPause(0)
				TrivTimers.timebreak = 0
				TrivTimers.breaktime = 0
				TrivTimers.showques = 0
			end
		end
	end

	-- Check if Trivia should be Autostoped
	if curTriv:GetGetQues() then
		if self._Sets.autostop and (curTriv.unansques == self._Sets.autostop) then
			TrivEx._Config.trivrun = 0

			curTriv:SetGetQues(1)
			self:WriteTable(self._Scores,"TrivEx._Scores",self._Sets.folder.."/"..TrivEx._Sets.ScoresFile)
			self:SendToPlayers("Trivia stoped due to Autostop, "..self._Sets.autostop.." questions weren't answered in a row.")
			return
		end
	end

	if (not curTriv:Pause()) then
		--Update ShowQuestion Time
		TrivTimers.showques = TrivTimers.showques + 1
		if (TrivTimers.showques == self._Sets.showques) then
			TrivTimers.showques = 0
			-- Check if to get new question
			if curTriv:GetNewQues() then
				curTriv:SendQuestion("NewQuestion")
				-- Count unsanswered questions one up
				curTriv.unansques = curTriv.unansques + 1
			else
				curTriv:UpdHint()
				if curTriv:GetGetQues() then
					-- Show the Answer
					curTriv:ShowAnswer()
					-- Check for Streak
					curTriv.streak:UpdStreak()
				else
					curTriv:SendQuestion("Hint")
				end
			end
		end
	end

	if (self._Sets.savestats ~= 0) then
		TrivTimers.savestats = TrivTimers.savestats + 1

		if TrivTimers.savestats >= self._Sets.savestats then

			TrivTimers.savestats = 0
			if (curTriv.streak.write_scores == 1) then
				self:WriteTable(self._Scores,"TrivEx._Scores",self._Sets.folder.."/"..TrivEx._Sets.ScoresFile)
				curTriv.streak.write_scores = 0
			end

		end
	end

end

function TrivEx:SendToUser(shub, snick, data)
	DC():SendHubMessage( shub:getId(), "$To: "..snick.." From: "..shub:getOwnNick().." $<"..shub:getOwnNick().."> "..data.."|")
end

function TrivEx:SendToPlayers(data)
	local hubs = dcpp:getHubs()
	table.foreach(hubs, function(_,shub)
		local ret = self:CheckOwnNick(shub)
		local ownNick = shub:getOwnNick()
		if ret and ownNick then
			DC():SendHubMessage( shub:getId(), "<"..ownNick.."> "..data.."|")
		end
	end)
end


function TrivEx:AllowedProf(status, shub, snick)
	local ownNick = shub:getOwnNick()
	if (ownNick == snick) then
		return 1
	end

	local sprofs = { "Config++","Config+","Config","Normal" }
	local siprofs = { ["Config++"] = 1, ["Config+"] = 2, ["Config"] = 3, ["Normal"] = 4, }

	local set = table.foreachi(sprofs, function(i,prof)
		if self._Config._Profiles[prof]["$OP"] and shub:isOp(snick) then
			return i
		end

		if self._Config._Profiles[prof][snick] or self._Config._Profiles[prof]["$ALL"] then
			return i
		end
	end)

	if siprofs[status] and set and (set <= siprofs[status]) then
		return 1
	end
end


--------------------------------------------
function TrivEx:LoadQuestions(getques)

	-- Set RandomSeed
	math.randomseed(os.clock())

	self._Questions = {n = 0}
	local howmany = self._Sets.memques
	if (self._Config.showquesmode == 1) and (not getques) then
		local getlines = {}
		for _ = 1,howmany do
			getlines[math.random(curTriv.totalques)] = 1
		end
		local handle = io.open(self._Sets.quesfolder.."/"..self._Config.questionfile,"r")

		if handle then
			local curTrivQuestions = {}
			local slinecount = 0
			for line in handle:lines() do
				slinecount = slinecount + 1
				if getlines[slinecount] then
					local cat,ques,ans = self:SplitLine(line)
					if (cat and ques and ans) then

						table.insert(curTrivQuestions,{cat,ques,ans,slinecount})

					end
				end

			end

			handle:close()
			for _ = 1,table.getn(curTrivQuestions) do
				local num = math.random(table.getn(curTrivQuestions))
				table.insert(self._Questions,curTrivQuestions[num])
				table.remove(curTrivQuestions,num)
			end					

		end
	elseif (self._Config.showquesmode == 2) or (getques) then
		self._Config.sequentialnum = self._Config.sequentialnum or 0
		local getlines = {}
		for _ = 1,howmany do
			self._Config.sequentialnum = self._Config.sequentialnum + 1
			if (self._Config.sequentialnum <= curTriv.totalques) then
				getlines[self._Config.sequentialnum] = 1
				if getques then
					break
				end
			else
				self._Config.sequentialnum = 0
			end
		end
		local handle = io.open(self._Sets.quesfolder.."/"..self._Config.questionfile,"r")
		if handle then
			local slinecount = 0
			for line in handle:lines() do
				slinecount = slinecount + 1
				if getlines[slinecount] then
					local cat,ques,ans = self:SplitLine(line)
					if (cat and ques and ans) then

						table.insert(self._Questions,{cat,ques,ans,slinecount})

					end
				end

			end

			handle:close()
		end
		if (not getques) or (self._Config.showquesmode == 2) then
			TrivEx:WriteTable(self._Config,"TrivEx._Config",self._Sets.folder.."/"..TrivEx._Sets.TrivConfigFile)
		end
	end	

end
function TrivEx:SplitLine(line,dividechar)

	if line then
		line = string.gsub(line,string.char(13),"")
	end

	local dividechar = dividechar or self._Sets.dividechar

	local swords = self:Tokenize(line, dividechar)
	if (self._Sets.quesmode == 1) and (table.getn(swords) > 2) then
		local cat = swords[1]
		table.remove(swords,1)
		local ques = swords[1]
		table.remove(swords,1)
		local ans = swords
		return cat,ques,ans

	elseif (self._Sets.quesmode == 2) and (table.getn(swords) > 1) then
		local cat = ""
		local ques = swords[1]
		table.remove(swords,1)
		local ans = swords
		return cat,ques,ans
	end
end
function TrivEx:Tokenize(curStr, stoken)
	local stable = {}

	local matcher = "([^"..stoken.."]+)"
	string.gsub(curStr,matcher, function(w) table.insert(stable,w) end)

	return stable
end

--------------------------------------------
function TrivEx:WriteTable(table,tablename,file)
	local handle = io.open(file,"w")
	self:Serialize(table,tablename,handle)
  	handle:close()
end
function TrivEx:Serialize(tTable,sTableName,hFile,sTab)
	sTab = sTab or "";
	hFile:write(sTab..sTableName.." = {\n");
	for key,value in tTable do
		if (type(value) ~= "function") then
			local sKey = (type(key) == "string") and string.format("[%q]",key) or string.format("[%d]",key);
			if(type(value) == "table") then
				self:Serialize(value,sKey,hFile,sTab.."\t");
			else
				local sValue = (type(value) == "string") and string.format("%q",value) or tostring(value);
				hFile:write(sTab.."\t"..sKey.." = "..sValue);
			end
			hFile:write(",\n");
		end
	end
	hFile:write(sTab.."}");
end
--------------------------------------------

------------------------
------------------------
function TrivEx:TrivHelp(shub, snick)
	if self:AllowedProf("Config++", shub, snick) then
		self:SendToUser(shub, snick, TrivEx.Data["HelpConfig++"])
	elseif self:AllowedProf("Config+", shub, snick) then
		self:SendToUser(shub, snick, TrivEx.Data["HelpConfig+"])
	elseif self:AllowedProf("Config", shub, snick) then
		self:SendToUser(shub, snick, TrivEx.Data.HelpConfig)
	elseif self:AllowedProf("Normal", shub, snick) then
		self:SendToUser(shub, snick, TrivEx.Data.HelpNormal)
	end
end

function TrivEx:TrivScore(shub, snick)
	if self:AllowedProf("Normal", shub, snick) then

		local msg = " -- Top "..self._Sets.displscorers.." Trivia Scorers --\r\n\r\n"

		for i = 1,self._Sets.displscorers do

			if self._Ranks[i] then
				v = self._Ranks[i]

				msg = msg.."\t# "..i.."  -  "..v.Nick..",  Points: "..v.Score.."\r\n"

			end

		end

		self:SendToUser(shub, snick, msg)
	end
end

function TrivEx:TrivMyScore(shub, snick)
	if self:AllowedProf("Normal", shub, snick) then
		if self._Scores[snick] then

			local irank = self._Scores[snick].Rank.Pos
			local Over = self._Scores[snick].Rank.Over
			local Under = self._Scores[snick].Rank.Under

			local msg = "\r\n"

			if (Over ~= snick) then
				local diff = self._Scores[Over].Score - self._Scores[snick].Score
				msg = msg.."\r\n\t\t# "..(irank-1).." - "..Over..",  Points: "..self._Scores[Over].Score..",  Diff = -"..diff.." Point(s)"
			end

			msg = msg.."\r\n\t---->\t# "..irank.." - "..snick..",  Points: "..self._Scores[snick].Score

			if (Under ~= snick) then
				local diff = self._Scores[snick].Score - self._Scores[Under].Score
				msg = msg.."\r\n\t\t# "..(irank+1).." - "..Under..",  Points: "..self._Scores[Under].Score..",  Diff = +"..diff.." Point(s)"
			end

			msg = msg.."\r\n\r\n"..
				"\t\tLongest Run = "..self._Scores[snick].Streak.."\r\n"..
				"\t\tAnswered Questions = "..self._Scores[snick].AnsQues.."\r\n"..
				"\t\tAverage Answering Time = "..self._Scores[snick].AvTime.."\r\n"

			local tmp = self._Scores[snick].TotTime
			local hours, minutes, secs = math.floor(tmp/(60*60)), math.floor(math.mod(tmp/60, 60)), math.floor(math.mod(tmp,60))

			if (hours > 0) then
				msg = msg.."\t\tSuccessfully wasted  "..hours.." hour(s)  "..minutes.." min(s)  "..secs.." sec(s)  of your time\r\n"
			else
				msg = msg.."\t\tSuccessfully wasted  "..minutes.." min(s)  "..secs.." sec(s)  of your time\r\n"
			end

			self:SendToUser(shub, snick, "------ "..snick.."'s Player Stats  -  Total Players = "..table.getn(self._Ranks).." ------"..msg )

		else
			self:SendToUser(shub, snick, "Your current score is : 0 Point(s).")
		end
	end
end
		 
function TrivEx:TrivStats(shub, snick)
	if self:AllowedProf("Normal", shub, snick) then
		
		local msg = "----- Top "..self._Sets.displtoptrivs.." Player Stats -----\r\n\r\n\tTop "..self._Sets.displtoptrivs.." Scorers\r\n\r\n"
		for i = 1,self._Sets.displtoptrivs do

			if self._Ranks[i] then
				v = self._Ranks[i]

				msg = msg.."\t# "..i.."  -  "..v.Nick..",  Points: "..v.Score.."\r\n"

			end

		end

		self:SortRankTable("Streak")

		local msg = msg.."\r\n\tTop "..self._Sets.displtoptrivs.." Runners\r\n\r\n"
		for i = 1,self._Sets.displtoptrivs do

			if self._Ranks[i] then
				v = self._Ranks[i]

				msg = msg.."\t# "..i.."  -  "..v.Nick..",  Run: "..v.Streak.."\r\n"

			end

		end

		self:SortRankTable("AvTime",1)

		local msg = msg.."\r\n\tTop "..self._Sets.displtoptrivs.." Typos\r\n\r\n"
		for i = 1,self._Sets.displtoptrivs do

			if self._Ranks[i] then
				v = self._Ranks[i]

				msg = msg.."\t# "..i.."  -  "..v.Nick..",  Average Answering Time: "..v.AvTime.."\r\n"

			end

		end

		self:SortRankTable("Score")

		self:SendToUser(shub, snick, msg)
	end
end

function TrivEx:TrivHallofFame(shub, snick)

	if self:AllowedProf("Normal", shub, snick) then
		
		-- Hall Of Fame
		local hof = self._HoFScores

		local msg = "\r\n~*~ * ~*~ * ~*~ * ~*~ * ~*~ * ~*~ * ~*~ * ~*~ * ~*~ * ~*~ * ~*~ * ~*~ * ~*~ * ~*~ ~*~\r\n"..
			"~*~ * ~*~ * ~*~ * ~*~ * ~*~ * ~*~ * ~*~ * ~*~ * ~*~ * ~*~ * ~*~ * ~*~ * ~*~ * ~*~ ~*~\r\n"..
			"\t\t<-= The Hall of Fame =->\r\n"

		msg = msg.."\r\n\t      -=          "..self._Sets.halloffamers.." Scorers          =-\r\n\r\n"

		table.foreachi(hof._Score, function(i, v)
			msg = msg.."\t#  "..string.format("% 3d",i).."\t\tScore  "..string.format("% 6d",v.Score).."\t"..v.Nick.."\r\n"
		end)

		msg = msg.."\r\n\t      -=          "..self._Sets.halloffamers.." Runners          =-\r\n\r\n"

		table.foreachi(hof._Run, function(i, v)
			msg = msg.."\t#  "..string.format("% 3d",i).."\t\tRun  "..string.format("% 3d",v.Run).."\t\t"..v.Nick.."\r\n"
		end)

		msg = msg.."\r\n~*~ * ~*~ * ~*~ * ~*~ * ~*~ * ~*~ * ~*~ * ~*~ * ~*~ * ~*~ * ~*~ * ~*~ * ~*~ * ~*~ ~*~\r\n"..
			"~*~ * ~*~ * ~*~ * ~*~ * ~*~ * ~*~ * ~*~ * ~*~ * ~*~ * ~*~ * ~*~ * ~*~ * ~*~ * ~*~ ~*~"

		self:SendToUser(shub, snick, msg)
	end
end

function TrivEx:DoTrivSkip(shub, snick)
	if self:AllowedProf("Normal", shub, snick) then
		if (self._Config.trivskip == 1) then
			if not curTriv:GetGetQues() then
				self:SendToPlayers("\""..snick.."\" has skipped this question.")

				curTriv:SetGetQues(1)
			else
				self:SendToUser(shub, snick, "No question to skip")
			end
		else

			self:SendToUser(shub, snick, "TriviaSkip is currently disabled.")
		end
	end
end

function TrivEx:DoTrivHint(shub, snick)
	if self:AllowedProf("Normal", shub, snick) then
		if (self._Config.trivhint == 1) then
			if not curTriv:GetGetQues() then

				self:SendToPlayers("\""..snick.."\" needs a hint.")

				curTriv:UpdHint()
				if curTriv:GetGetQues() then
					curTriv:ShowAnswer()
				else
					curTriv:SendQuestion()
				end
			else

				self:SendToUser(shub, snick, "No question given")

			end
		else

			self:SendToUser(shub, snick, "TriviaHint is currently disabled.")

		end
	end
end
------------------------
------------------------
function TrivEx:TrivStart(shub, snick)
	if self:AllowedProf("Config", shub, snick) then
		if curTriv:Pause() then
			self:SendToUser(shub, snick, "Tivia is paused, will start automatically again")
		else
			curTriv.unansques = 0
			curTriv:SetGetQues(1)
			self._Config.trivrun = 1
			self:WriteTable(self._Config,"TrivEx._Config",self._Sets.folder.."/"..self._Sets.TrivConfigFile)
			self:SendToPlayers("Trivia was started by "..snick)
		end
	end

end


function TrivEx:TrivStop(shub, snick)
	if self:AllowedProf("Config", shub, snick) then
		self._Config.trivrun = 0

		curTriv:SetGetQues(1)
		self:WriteTable(self._HallofFames,"TrivEx._HallofFames",self._Sets.folder.."/"..self._Sets.HallofFamesFile)
		self:WriteTable(self._Scores,"TrivEx._Scores",self._Sets.folder.."/"..self._Sets.ScoresFile)
		self:WriteTable(self._Config,"TrivEx._Config",self._Sets.folder.."/"..self._Sets.TrivConfigFile)
		self:SendToPlayers("Trivia was stoped by "..snick)
	end

end

function TrivEx:LoadQuestion(shub, snick, data)
	if self:AllowedProf("Config", shub, snick) then
		local _,_,arg1 = string.find(data,"%S+%s+(%d+)")
		local num = tonumber(arg1) or 1
		self._Config.sequentialnum = num-1
		self:LoadQuestions(1)
		curTriv:SetGetQues(1)
		self:SendToPlayers(snick.." is trying to load QuestionNr. "..num)
	end
end	

function TrivEx:AddQuestion(shub, snick, data)
	if self:AllowedProf("Config", shub, snick) then
		local _,_,newquestion = string.find(data,"^%S+%s+(.*)")
		if newquestion then
			local Cat,Ques,tAns = self:SplitLine(newquestion,"/")
			if Ques and Ques ~= "" then
				local handle = io.open(self._Sets.folder.."/"..self._Sets.addquestionfile,"a")
				if (self._Sets.quesmode == 1) then
					local msg = ""
					msg = msg.."Category: "..Cat..", Question: "..Ques..", "
					handle:write(Cat..self._Sets.dividechar..Ques)
					for i = 1,table.getn(tAns) do
						msg = msg.."Answer"..i..": "..tAns[i]..", "
						handle:write(self._Sets.dividechar..tAns[i])
					end
					handle:write("\n")
					self:SendToUser(shub, snick, "Added Question: "..msg)
				elseif (self._Sets.quesmode == 2) then
					local msg = ""
					msg = msg.."Question: "..Ques..", Answers: "
					handle:write(Ques)
					for i = 1,getn(tAns) do
						msg = msg..tAns[i]..", "
						handle:write(self._Sets.dividechar..tAns[i])
					end
					handle:write("\n")
					self:SendToUser(shub, snick, "Added Question: "..msg)
				end
				handle:close()
			else
				self:SendToUser(shub, snick, "Couldn't parse Question: "..newquestion)
			end
		else
			self:SendToUser(shub, snick, "No Question given!")
		end
	end
end
------------------------
------------------------
function TrivEx:ConfTrivSkip(shub, snick)
	if self:AllowedProf("Config+", shub, snick) then
		if (self._Config.trivskip == 1) then
			self._Config.trivskip = 0
			self:WriteTable(self._Config,"TrivEx._Config",self._Sets.folder.."/"..self._Sets.TrivConfigFile)
			self:SendToUser(shub, snick, "TriviaSkip is now disabled.")
		elseif (self._Config.trivskip == 0) then
			self._Config.trivskip = 1
			self:WriteTable(self._Config,"TrivEx._Config",self._Sets.folder.."/"..self._Sets.TrivConfigFile)
			self:SendToUser(shub, snick, "TriviaSkip is now enabled.")
		end
	end
end

function TrivEx:ConfTrivHint(shub, snick)
	if self:AllowedProf("Config+", shub, snick) then
		if (self._Config.trivhint == 1) then
			self._Config.trivhint = 0
			self:WriteTable(self._Config,"TrivEx._Config",self._Sets.folder.."/"..self._Sets.TrivConfigFile)
			self:SendToUser(shub, snick, "TriviaHint is now disabled.")
		elseif (self._Config.trivhint == 0) then
			self._Config.trivhint = 1
			self:WriteTable(self._Config,"TrivEx._Config",self._Sets.folder.."/"..self._Sets.TrivConfigFile)
			self:SendToUser(shub, snick, "TriviaHint is now enabled.")
		end
	end
end

function TrivEx:ResetScore(shub, snick)
	if self:AllowedProf("Config+", shub, snick) then
		self._Scores = {}
		self._Ranks = {n = 0}

		self:WriteTable(self._Scores,"TrivEx._Scores",self._Sets.folder.."/"..self._Sets.ScoresFile)

		self:SendToUser(shub, snick, "The scores have been reseted.")
	end

end

function TrivEx:ChangeQuesMode(shub, snick)
	if self:AllowedProf("Config+", shub, snick) then
		if (self._Config.showquesmode == 1) then
			self._Config.showquesmode = 2
			self:LoadQuestions()
			self:SendToUser(shub, snick, "Questionmode is set to Sequential.")
		elseif (self._Config.showquesmode == 2) then
			self._Config.showquesmode = 1
			self:LoadQuestions()
			self:SendToUser(shub, snick, "Questionmode is set to Random.")
		end

		self:WriteTable(self._Config,"TrivEx._Config",self._Sets.folder.."/"..self._Sets.TrivConfigFile)
	end

end

function TrivEx:ListQuestionFiles( shub, snick )
	if self:AllowedProf("Config+", shub, snick) then

		os.execute("dir \""..self._Sets.quesfolder.."\" /a-d /b > questionfiles.txt")

		self:SendToUser(shub, snick, "Questionfiles:")

		for line in io.lines("questionfiles.txt","r") do
			self:SendToUser(shub, snick, "\t"..line)
		end
		
		os.remove( "questionfiles.txt" )
	end
end

function TrivEx:LoadQuestionFile( shub, snick, sdata )
	if self:AllowedProf("Config+", shub, snick) then
		local _,_,questionfile = string.find(sdata,"^%S+%s+(%S+)")
		if questionfile then
			self._Config.questionfile = questionfile
			curTriv.totalques = self:GetTotalQues()
			self:WriteTable(self._Config,"TrivEx._Config",self._Sets.folder.."/"..self._Sets.TrivConfigFile)
			self:LoadQuestions()
			curTriv:SetGetQues(1)
			self:SendToUser(shub, snick, "Setted Questionfile to "..questionfile)
		else
			self:SendToUser(shub, snick, "Syntax +trivialoadqfile <questionfile>")
		end
	end
end

-------------------------
-------------------------
function TrivEx:AddDelProf(shub, snick, sdata)
	if self:AllowedProf("Config++", shub, snick) then
		local _,_,prof,curprof = string.find(sdata,"^%S+%s+(%S+)%s+(%S+)")
		if prof and curprof then
			if self._Config._Profiles[prof] then
				if self._Config._Profiles[prof][curprof] then
					self._Config._Profiles[prof][curprof] = nil
					self:WriteTable(self._Config,"TrivEx._Config",self._Sets.folder.."/"..self._Sets.TrivConfigFile)
					self:SendToUser(shub, snick, "In Profile \""..prof.."\", \""..curprof.."\" was delted from ProfilesList")
				else
					self._Config._Profiles[prof][curprof] = 1
					self:WriteTable(self._Config,"TrivEx._Config",self._Sets.folder.."/"..self._Sets.TrivConfigFile)
					self:SendToUser(shub, snick, "In Profile \""..prof.."\", \""..curprof.."\" was added to ProfilesList")
				end
			else
				self:SendToUser(shub, snick, "\""..prof.."\" no such Profile, Currently in ProfilesList:")
				table.foreach(self._Config._Profiles, function(prof,v)
					self:SendToUser(shub, snick, "  Profile:  "..prof)
					table.foreach(v, function(curprof,_)
						self:SendToUser(shub, snick, "  -  "..curprof)
					end)
				end)
			end
		else
			self:SendToUser(shub, snick, "Currently in ProfilesList:")
			table.foreach(self._Config._Profiles, function(prof,v)
				self:SendToUser(shub, snick,"")
				self:SendToUser(shub, snick, "  Profile:  "..prof)
				table.foreach(v, function(curprof,_)
					self:SendToUser(shub, snick, "  -  "..curprof)
				end)
			end)
		end
	end
end

---------------------------------------------------------------------------------------

--	TRIVIA EX COMMANDS

---------------------------------------------------------------------------------------
TrivEx._Cmds = {}

-- Normal Commands

TrivEx._Cmds.trivhelp = TrivEx.TrivHelp			-- Trivia Help

TrivEx._Cmds.trivscore = TrivEx.TrivScore		-- Shows the Ranking of the best Trivias
TrivEx._Cmds.trivmyscore = TrivEx.TrivMyScore		-- Shows only your score
TrivEx._Cmds.trivstats = TrivEx.TrivStats		-- Shows the top "TrivEx._Sets.displtoptrivs" player stats
TrivEx._Cmds.trivhf = TrivEx.TrivHallofFame		-- Shows you the guys from Hallof Fame
TrivEx._Cmds.trivskip =	TrivEx.DoTrivSkip		-- Lets you skip a question, trivskip
TrivEx._Cmds.trivhint =	TrivEx.DoTrivHint		-- Gives you a Hint

-- Configure Commands

TrivEx._Cmds.trivstart = TrivEx.TrivStart		-- Strats Trivia

TrivEx._Cmds.trivstop =	TrivEx.TrivStop			-- Stops Trivia

TrivEx._Cmds.trivquestion = TrivEx.LoadQuestion		-- Expects a number as argument, e.g. +trivquestion 111
TrivEx._Cmds.trivaddq = TrivEx.AddQuestion		-- Lets you add a question to a file

-- Configure+ Commands

TrivEx._Cmds.triviaskip = TrivEx.ConfTrivSkip		-- Enables/Disables triviaskip

TrivEx._Cmds.triviahint = TrivEx.ConfTrivHint		-- Enables/Disables triviahint
TrivEx._Cmds.triviamain = TrivEx.PlayTrivMain		-- Allows you to play in Main
TrivEx._Cmds.triviapm = TrivEx.PlayTrivPM		-- Allows you to play in PM, implements the regging of a bot
TrivEx._Cmds.triviascorereset =	TrivEx.ResetScore	-- Resets the Trivia Score
TrivEx._Cmds.triviachangemode = TrivEx.ChangeQuesMode	-- Chages the Question Mode
TrivEx._Cmds.trivialistqfiles = TrivEx.ListQuestionFiles -- Lists the Questionfiles
TrivEx._Cmds.trivialoadqfile = TrivEx.LoadQuestionFile	--Loads a question file

-- Configure++ Commands

TrivEx._Cmds.triviaprofile = TrivEx.AddDelProf		-- List/Add/Del Profiles

---------------------------------------------------------------------------------------

--	TRIVIA GAME

---------------------------------------------------------------------------------------


-- Timers
TrivTimers = {}
TrivTimers.timebreak = 0
TrivTimers.breaktime = 0
TrivTimers.showques = 0
TrivTimers.savestats = 0

UnRevealed = {}
FirstLetters = {}

-- Current TriviaGame
curTriv = {}

curTriv.unansques = 0

curTriv.totalques = 0
curTriv.pause = 0
curTriv.getques = 1

curTriv.quesnum = 0
curTriv.cat = ""
curTriv.ques = ""
curTriv.ans = {}
curTriv.availans = 0
curTriv.points = 0
curTriv.hint = ""

curTriv.unrevealed = {}
curTriv.unrevealed.fl = {n = 0}
curTriv.unrevealed.ol = {n = 0}

curTriv.revealnum = 0

curTriv.streak = {}
curTriv.streak.nick = ""
curTriv.streak.streak = 0
curTriv.streak.write_scores = 0

-- funcs curTriv.streak
curTriv.streak.UpdStreak = function(self, snick)

	if snick then

		-- Write Scores by next saving
		self.write_scores = 1

		-- Set Unanswered Questions to zero
		curTriv.unansques = 0

		if (self.nick == snick) then

			local ret = 0

			self.streak = self.streak + 1
			if (self.streak > TrivEx._Scores[snick].Streak)  then
				ret = table.foreachi(TrivEx._Sets.OwnStreak, function(_,v)
					local runtrig = v[1]
					if (self.streak >= runtrig) then
						local phrase = curTriv:Gsub(v[2], snick)
						TrivEx:SendToPlayers(phrase)
						return 1
					end
				end)
				TrivEx._Scores[snick].Streak = self.streak
			end

			if (ret == 0) then
				table.foreachi(TrivEx._Sets.IncStreak, function(_,v)
					local runtrig = v[1]
					if (self.streak == runtrig) then
						local phrase = curTriv:Gsub(v[2], snick)
						TrivEx:SendToPlayers(phrase)
						return 1
					end
				end)
			end

		else

			table.foreachi(TrivEx._Sets.BrkStreakUser, function(_,v)
				local runtrig = v[1]
				if (self.streak >= runtrig) then
					local phrase = curTriv:Gsub(v[2], snick)
					TrivEx:SendToPlayers(phrase)
					return 1
				end
			end)
			self.nick = snick
			self.streak = 1
		end

	else

		if (self.nick ~= "") then
			table.foreachi(TrivEx._Sets.BrkStreak, function(_,v)
				local runtrig = v[1]
				if (self.streak >= runtrig) then
					local phrase = curTriv:Gsub(v[2])
					TrivEx:SendToPlayers(phrase)
					return 1
				end
			end)
		end
		self.nick = ""
		self.streak = 0
	end
end

-- funcs curTriv

function curTriv:Gsub(tphrase, snick)

	-- Set RandomSeed
	math.randomseed(os.clock())

	local rannum = math.random(1,table.getn(tphrase))

	local phrase = tphrase[rannum]

	phrase = string.gsub(phrase,"%b[]", function(w)
		if (w == "[Nick]") then
			return self.streak.nick
		elseif (w == "[Breaker]") then
			return snick or nil
		elseif (w == "[Run]") then
			return self.streak.streak
		end
	end)

	return phrase

end 


function curTriv:Pause()
	if (self.pause == 1) then
		return 1
	end
end

function curTriv:SetPause(arg)
	self.pause = arg
end

function curTriv:GetNewQues()
	if (self.getques == 1) then
		self:GetQuestion()
		return 1
	end
end

function curTriv:GetQuestion()
	if not TrivEx._Questions[1] then
		TrivEx._Config.trivrun = 0
		DC():PrintDebug("Trivia Error: No Questionfile or Questions found (Trivia is stoped)")
		return
	end

	self.quesnum = TrivEx._Questions[1][4]

	self.cat = TrivEx._Questions[1][1]
	if (self.cat == "") then
		self.cat = "N/A"
	end
	self.ques = TrivEx._Questions[1][2]
	self.ans = TrivEx._Questions[1][3]
	self.availans = table.getn(self.ans)

	table.remove(TrivEx._Questions,1)

	self.points = 0
	self.hint = string.gsub(self.ans[1],"(%S)",function(w)  self.points = self.points + 1 return(TrivEx._Sets.revealchar) end)

	self.unrevealed.fl = {n = 0}
	self.unrevealed.ol = {n = 0}
	for i = 1,string.len(self.hint) do
		if (string.sub(self.hint,i,i) == TrivEx._Sets.revealchar) then
			if (TrivEx._Sets.revealques == 2) and ((i == 1) or (string.sub(self.hint,(i-1),(i-1)) == " ")) then
				table.insert(self.unrevealed.fl,i)
			else
				table.insert(self.unrevealed.ol,i)
			end
		end
	end
				
	if (TrivEx._Sets.trivshowhint == 2) then
		if ((self.points/TrivEx._Sets.shownhints - math.floor(self.points/TrivEx._Sets.shownhints)) >= 0.5) then
			self.revealnum = math.floor(self.points/TrivEx._Sets.shownhints) + 1
		elseif (math.floor(self.points/TrivEx._Sets.shownhints) == 0) then
			self.revealnum = 1
		else
			self.revealnum = math.floor(self.points/TrivEx._Sets.shownhints)
		end
	else
		self.revealnum = TrivEx._Sets.revealedchars
	end
	self.start = os.clock()
	self:SetGetQues(0)

end

function curTriv:SetGetQues(arg)
	TrivTimers.showques = 0
	self.getques = arg
end

function curTriv:GetGetQues()
	if (self.getques == 1) then	
		return 1
	end
end

function curTriv:SendQuestion(what)

	--TrivEx:SendToPlayers("ANS: "..self.ans[1])

	if (what == "Hint") and TrivEx._Sets.showseparatehint then

		TrivEx:SendToPlayers(" HINT:  "..self.hint.."\r\n")

	else

		if (TrivEx._Sets.showquestion == 1) then
			TrivEx:SendToPlayers("QUESTION - Nr. "..self.quesnum.." of "..self.totalques.."\r\n\r\n"..

			"\t> Category: "..self.cat.." - Point(s): "..self.points.." - Total Answers: "..self.availans.."\r\n"..

			"\t"..self:doSplitQuestion("QUESTION: "..self.ques).."\r\n"..

			"\tHINT:  "..self.hint.."\r\n")
		elseif (TrivEx._Sets.showquestion == 2) then
			TrivEx:SendToPlayers("QUESTION - Nr. "..self.quesnum.." of "..self.totalques.."\r\n\r\n"..
			"\t> Point(s): "..self.points.." - Total Answers: "..self.availans.."\r\n"..

			"\t"..self:doSplitQuestion("QUESTION: "..self.ques).."\r\n"..

			"\tHINT:  "..self.hint.."\r\n")
		elseif (TrivEx._Sets.showquestion == 3) then
			TrivEx:SendToPlayers("\r\n\r\n"..

			"\t"..self:doSplitQuestion("QUESTION: "..self.ques).."\r\n"..

			"\tHINT:  "..self.hint.."\r\n")
		end
	end

end

function curTriv:doSplitQuestion(sQues)
	for i = TrivEx._Sets.splitques,string.len(sQues) do
		if (string.sub(sQues,i,i) == " ") then
			local srest = string.sub(sQues,(i+1),string.len(sQues))
			srest = self:doSplitQuestion(srest)
			return (string.sub(sQues,1,(i-1)).."\r\n\t "..srest)
		end
	end
	return(sQues)
end

function curTriv:UpdHint()
	local thint = self:toTable(self.hint)
	if (TrivEx._Sets.revealques == 1) then
		for _ = 1,curTriv.revealnum do
			if (table.getn(curTriv.unrevealed.ol) ~= 0) then
				local rannum = math.random(table.getn(curTriv.unrevealed.ol))
				local strnum = curTriv.unrevealed.ol[rannum]
				thint[strnum] = string.sub(self.ans[1],strnum,strnum)
				curTriv.points = curTriv.points - 1
				table.remove(curTriv.unrevealed.ol,rannum)
			end
		end
	elseif(TrivEx._Sets.revealques == 2) then
		for _ = 1,curTriv.revealnum do
			if (table.getn(curTriv.unrevealed.fl) ~= 0) then
				local rannum = math.random(table.getn(curTriv.unrevealed.fl))
				local strnum = curTriv.unrevealed.fl[rannum]
				thint[strnum] = string.sub(self.ans[1],strnum,strnum)
				curTriv.points = curTriv.points - 1
				table.remove(curTriv.unrevealed.fl,rannum)
			elseif (table.getn(curTriv.unrevealed.ol) ~= 0) then
				local rannum = math.random(table.getn(curTriv.unrevealed.ol))
				local strnum = curTriv.unrevealed.ol[rannum]
				thint[strnum] = string.sub(self.ans[1],strnum,strnum)
				curTriv.points = curTriv.points - 1
				table.remove(curTriv.unrevealed.ol,rannum)
			end
		end
	end
	self.hint = self:toString(thint)
	if ((table.getn(curTriv.unrevealed.fl)+table.getn(curTriv.unrevealed.ol)) <= TrivEx._Sets.solveques) then
		self.hint = self.ans[1]
		self:SetGetQues(1)
	end
end

function curTriv:toTable(sstring)
	local ttable = {n = 0}
	for i = 1,string.len(sstring) do
		table.insert(ttable,string.sub(sstring,i,i))
	end
	return ttable
end

function curTriv:toString(ttable)
	local sstring = ""
	for i = 1,table.getn(ttable) do
		sstring = sstring..ttable[i]
	end
	return(sstring)
end

function curTriv:ShowAnswer()
	TrivEx:SendToPlayers("The answer is:  "..curTriv.ans[1])
	if curTriv.availans > 1 then
		local msg = ""
		for i = 2,curTriv.availans do
			msg = msg..curTriv.ans[i]..", "
		end
		msg = string.sub(msg,1,string.len(msg)-2)
		TrivEx:SendToPlayers("Other answers were: "..msg)
	end
end

TrivEx:Main()

----------------------------
----------------------------
DC():PrintDebug( "  ** Loaded TriviaEx.Server.003.lua **" )

